PAGE 60,132
TITLE ASPI DOS Single Disk Device Driver (C) 1991 Adaptec, Inc.

;****************************************************************************
;*									    *
;* Copyright 1991 Adaptec, Inc.,  All Rights Reserved.	 		    *
;*									    *
;* This software contains the valuable trade secrets of Adaptec.  The	    *
;* software is protected under copyright laws as an unpublished work of	    *
;* Adaptec.  Notice is for informational purposes only and does not imply   *
;* publication.  The user of this software may make copies of the software  *
;* for use with parts manufactured by Adaptec or under license from Adaptec *
;* and for no other use.						    *
;*									    *
;****************************************************************************

;****************************************************************************
;*
;*  Driver Name:  ASPI1DSK.SYS
;*
;*  Version:	  1.0
;*
;*  Source Code:  ASPI1DSK.ASM    MESSAGES.ASM    ASPI1DSK.INC
;*		  ASPIDEFS.INC    SCSIDEFS.INC    MAKEFILE
;*
;*  Base Code #:  537802-00      
;*
;*  Description:  This driver, ASPI1DSK.SYS, is a subset of Adaptec's DOS
;*		  SCSI Driver named (ASPIDISK.SYS).
;*
;*		  - You should have an understanding of writing DOS device
;*		    drivers, and DOS' partitioning scheme to fully understand
;*		    this driver.
;*
;*		  - There are NO command line switches.  The driver will
;*		    automatically scan ASPI's device table and attach the
;*		    first available disk drive it finds (ie. NOT under BIOS
;*		    control).
;*
;*		  - Removable media is NOT supported.  The driver will still
;*		    accept removable media drives but will treat them as a
;*		    fixed disk.  DO NOT REMOVE THE MEDIA ON A REMOVABLE
;*		    MEDIA DRIVE WHEN USING THIS DRIVER!!!
;*
;*		  - Only one disk drive is supported.
;*
;*		  - Only the primary DOS compatible partition is supported,
;*		    hence ONLY ONE partition is supported.
;*
;*		  - Only those ASPI managers which support the new ASPI
;*		    Command Code #6 (Get Disk Drive Information) are
;*		    supported (ie. ASPI4DOS.SYS v3.0 & ASPIEDOS.SYS v1.0).
;*
;*		  - DOS' Generic IOCTL is NOT supported.  Utilities such as
;*		    FORMAT.COM will not work with this driver.  Use AFDISK
;*		    to partition and format your drives.
;*
;*		  - This driver will work with DOS 3.21 and above, including
;*		    DOS 3.3 / 3.31 / 4.0 / 5.0.
;*
;*		  - Initialization code and data are thrown away after INIT
;*		    to minimize resident memory requirements.
;*
;*		  - The resident memory requirements of this driver are less
;*		    than 1K.
;*
;*  History:
;*
;*     07/20/91 - MDB - v1.0 submitted.
;*
;****************************************************************************

		.286
page
		include	aspi1dsk.inc		;ASPI1DSK.SYS definitions
page
		include	scsidefs.inc		;SCSI definitions
page
		include aspidefs.inc		;ASPI definitions
page
		assume	cs:ASPISeg,ds:ASPISeg,es:nothing

;****************************************************************************
;	      %%% EXTERNAL STRINGS (in MESSAGES.ASM) %%%
;****************************************************************************
DataInit	segment
		extrn	MsgSignOn:	near	;Please refer to the module
		extrn	MsgInstallGood:	near	;  "MESSAGES.ASM" for a
		extrn	MsgInstallFail:	near	;  description of each of
		extrn	Str_NoDrives:	near	;  these strings.
		extrn	Str_BootFail:	near
		extrn	Str_NoASPI:	near
		extrn	Str_OldDOS:	near
		extrn	Str_TargetInfo1:near
		extrn	Str_TargetInfo2:near
		extrn	Str_TargetInfo3:near
		extrn	Str_OldASPIMgr:	near
		extrn	Str_CRLF:	near
DataInit	ends

;****************************************************************************
;	   %%% DATA - KEEP SEGMENT AFTER INITIALIZATION %%%
;****************************************************************************
ScsiData	segment

MajorDosVer	db	0			;Major DOS version
MinorDosVer	db	0			;Minor DOS version

Req_Header	label	DWORD			;DOS request header is
Req_Header_Off	dw	?			;  stored here by the
Req_Header_Seg	dw	?			;  strategy routine

bpb_tbl		DRV_BPB <>			;Drive BPB
bpb_ptr		dw	1 dup(?)		;Pointer to drive BPB

ASPI_Entry	dd	0			;Pointer to ASPI
HANumber	db	0			;Number of host adapters

req_cmd		db	0			;Type of command to execute

SRB	  	SRB_with_CDB10 <>		;Our SCSI Request Block (SRB)

cmd_table	label 	word
		dw  CodeOffset DriverInit	; 0 - Initialization
		dw  CodeOffset MediaCheck	; 1 - Media check
		dw  CodeOffset BuildBPB		; 2 - Build BPB
		dw  CodeOffset CmdNotSupported	; 3 - IOCTL input
		dw  CodeOffset DiskInput	; 4 - Input
		dw  CodeOffset CmdNotSupported	; 5 - Non destructive input no wait
		dw  CodeOffset CmdNotSupported	; 6 - Input status
		dw  CodeOffset CmdNotSupported	; 7 - Input flush
		dw  CodeOffset DiskOutput	; 8 - Output
		dw  CodeOffset OutputVerify	; 9 - Output with verify
		dw  CodeOffset CmdNotSupported	;10 - Output status
		dw  CodeOffset CmdNotSupported	;11 - Output flush
		dw  CodeOffset CmdNotSupported	;12 - IOCTL output
		dw  CodeOffset DeviceOpenClose	;13 - Device OPEN
		dw  CodeOffset DeviceOpenClose	;14 - Device CLOSE
		dw  CodeOffset RemovableMedia	;15 - Removable media 
		dw  CodeOffset CmdNotSupported	;16 - reserved
		dw  CodeOffset CmdNotSupported	;17 - reserved
		dw  CodeOffset CmdNotSupported	;18 - reserved
		dw  CodeOffset CmdNotSupported	;19 - Generic IOCTL 
		dw  CodeOffset CmdNotSupported	;20 - reserved
		dw  CodeOffset CmdNotSupported	;21 - reserved
		dw  CodeOffset CmdNotSupported	;22 - reserved
		dw  CodeOffset GetSetDevice	;23 - Get logical device
		dw  CodeOffset GetSetDevice	;24 - Set logical device
MAX_CMD =	($ - cmd_table) / 2		;Maximum valid command 	

ScsiData	ends

;****************************************************************************
;	%%% DATA - THROW SEGMENT AWAY AFTER INITIALIZATION %%%
;****************************************************************************
DataInit	segment

SCSIMgrString	db	"SCSIMGR$",0		;SCSI manager name

TargetID	db	?			;Drive target number

NumberOfHA	db	0			;Number of host adapters

NumberOfUnits	db	0			;Number of units

OrigUnitNum	db	0			;Original unit number

TempBuffer	db	10 dup (?)		;Temporary string buffer

OldASPIGiven	db	0			;User notified of old style
						;  ASPI manager found? (0=no)

mbrbuf		db	200h dup(0)		;Master boot record buffer
brdbuf		db	200h dup(0)		;Boot record buffer

DataInit	ends

;****************************************************************************
;		  %%% THROW AWAY SEGMENT MARKER %%%
;****************************************************************************
ThrowAwaySeg	segment		;This segment sits between the code/data we
EndDriverPtr1	label	byte	;  want to keep and the code/data we want to
ThrowAwaySeg	ends		;  throw away after INIT.  It is done this
				;  way for compatability among the various
				;  assemblers.

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		   %%% BEGINNING OF THE DRIVER %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

;****************************************************************************
;		%%% ASPI1DSK.SYS DOS DEVICE HEADER %%%
;****************************************************************************
CDDHeader	segment
start:		org	0
		dd	-1			;Pointer to Next Device
attribute	dw	6800h			;Attributes
		dw	CodeOffset DriverStrat	;Strategy Routine
		dw	CodeOffset DriverIntr	;Interrupt Routine
		db	1			;Number of block devices
		db	'AHADDVR'		;Marker
CDDHeader	ends

;****************************************************************************
; Subroutine Name:  DriverStrat
;
; Description:  This routine handles the SCSI manager strategy routine
;		by simply saving a pointer to the request header.  Note
;		that the Strategy routine is defined as a FAR procedure.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   ES:BX - Request Packet
;****************************************************************************
ScsiCode	segment
DriverStrat	proc	far
		mov	cs:Req_Header_Off,bx	;Save the request pointer
		mov	cs:Req_Header_Seg,es	;Save the request pointer
		ret
DriverStrat	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  DriverIntr
;
; Description:  This routine handles the driver's interrupt routine.  It
;		performs the command specified in the request header.  Note
;		that this routine is also defined as a FAR procedure.
;
; Entry:  Req_Header - Request Packet
;
; Exit:   All registers preserved
;****************************************************************************
ScsiCode	segment
DriverIntr	proc	far
		pusha				;Save all registers
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax			;DS=CS

		les	bx,Req_Header		;ES:BX = Request packet
		mov	al,es:[bx].command	;Get command code
		cbw				;AX = command code

		cmp	al,MAX_CMD		;Valid command code?
		jbe	cmd_in_range		;Branch if supported
		mov	ax,(STAT_ERR SHL 8)+STAT_CMDERR
		jmp	SHORT MgrIntrExit	;Unsupported command, exit

cmd_in_range:	shl	ax,1			;AX = Command Code *2
		mov	si,ax			;SI = AX
		call	cmd_table[si]		;Call command handler

MgrIntrExit:	les	bx,Req_Header		;ES:BX = Request packet
		or	ah,STAT_DONE		;Mark status as done
		mov	es:[bx].status,ax	;Store packet's status

		pop	es
		pop	ds
		popa				;Restore all registers
		ret				;  and return to caller
DriverIntr	endp
ScsiCode	ends

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		    %%% DRIVER INITIALIZATION %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

;****************************************************************************
; Subroutine Name:  DriverInit
;
; Description:  This routine handles the driver's initialization.
;
; Entry:  [Req_Header] - Driver initialization request header
;
; Exit:   AX - Driver initilization error code (0=no error)
;****************************************************************************
CodeInit	segment
DriverInit	proc	near
		lea	dx,MsgSignOn
		call	outtext			;Display driver banner

		les	bx,[Req_Header]		;ES:BX -> Request Header
		mov	al,es:[bx].drv_num	;Get/Save # of block device
		mov	NumberOfUnits,al	;  units already present

		call	GetDosVersion		;Get DOS version
		jc	InitFail		;Branch if unsupported ver.

		call	GetASPIEntry		;Get ASPI Entry point
		jc	InitFail		;Branch if no ASPI present

		call	FindDiskDrive		;Find/Store SCSI drive
		jc	InitFail		;Branch if failed

		call	GetBPBInfo		;Find/Attach logical drive
		jc	InitFail		;Branch if failed

		lea	dx,MsgInstallGood
		call	outtext			;Driver installed / no errors

		les	bx,[Req_Header]		;ES:BX -> Request Header
		mov	es:[bx].units,1		;Return # units to DOS

		mov	es:[bx].end_off,DataOffset EndDriverPtr1
		mov	es:[bx].end_seg,cs	;End Pointer segment
		mov	es:[bx].bpb_off,DataOffset bpb_ptr
		mov	es:[bx].bpb_seg,cs	;Array of BPB pointers
		xor	ax,ax			;Return with no error
		ret

InitFail:	lea	dx,MsgInstallFail
		call	outtext			;Display install failed

		les	bx,[Req_Header]		;ES:BX -> Request Header
		mov	es:[bx].end_off,0	;Don't load ASPI1DSK.SYS
		mov	es:[bx].end_seg,cs
		mov	ah,stat_err
		mov	al,stat_genf		;Set general failure flag
		ret
DriverInit	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  GetDosVersion
;
; Description:  This routine determines the version of DOS that is running.
;		If it's DOS 3.21 and above, there is no error, else an
;		appropriate error message will be displayed.  Also, if
;		this DOS 4.0 or above, the device driver header will be
;		marked for support of 32-bit sectors numbers.
;
; Entry:  Nothing
;
; Exit:   MajorDosVer set
;	  MinorDosVer set
;	  CF set if unsupported DOS version, else reset
;****************************************************************************
CodeInit	segment
GetDosVersion	proc	near
		mov	ah,30h
		int	21h			;Get DOS Version
		jc	InvalidDosVer		;Branch if DOS call failed
		mov	MajorDosVer,al		;Save DOS Major version
		mov	MinorDosVer,ah		;Save DOS Minor version
		cmp	al,3			;Greater than DOS 3?
		ja	Dos4AndAbove		;Branch if it is
		cmp	ah,31			;Branch if greater than
		jae	Dos4AndAbove		;  DOS 3.31
		cmp	ah,21			;Greater than/equal DOS 3.21?
		jae	ValidDosVer		;Branch if it is

InvalidDosVer:	lea	dx,Str_OldDOS		;Unsupported DOS version
		call	outtext			;Display appropriate message
		stc				;  and return with carry set
		ret

Dos4AndAbove:	or	attribute,02		;Can handle 32-bit sectors
ValidDosVer:	clc				;Valid DOS version, return
		ret				;  with carry clear
GetDosVersion	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  GetASPIEntry
;
; Description:  This gets the ASPI manager's entry point and stores it in
;		'ASPI_Entry.'  The 'NumberOfHA' field will also be
;		initialized to the number of ASPI host adapters installed.
;		If no ASPI manager is located, an appropriate error message
;		is displayed.
;
;		NOTE:  After we get the ASPI entry point, we close the
;		       file handle.  The entry point is static!
;
; Entry:  Nothing
;
; Exit:	  CF set if no ASPI manager found, else reset
;****************************************************************************
CodeInit	segment
GetASPIEntry	proc	near
		mov	ax,ASPI_OPEN
		lea	dx,SCSIMgrString 
		int	21h			;Open ASPI Manager
		jc	NoASPIManager		;Branch if none found
		push	ax			;Save ASPI File Handle

		mov	bx,ax			;BX = File Handle
		mov	ax,ASPI_GET_ENTRY
		lea	dx,ASPI_Entry		;Store entry point here
		mov	cx,4			;Four bytes to transfer
		int	21h			;Get ASPI entry point

		mov	ax,ASPI_CLOSE
		pop	bx			;BX = ASPI File Handle
		int	21h			;Close ASPI Manager

		lea	si,SRB
		call	ClearSRB		;Zero out our SRB
		push	ds			;We're going to issue an
		push	DataOffset SRB		;  ASPI Host Adapter Inquiry
		call	[ASPI_Entry]		;Call ASPI
		add	sp,4			;Restore stack

		mov	al,SRB.HA_Count		;Get # of ASPI host adapters
		mov	NumberOfHA,al		;Save it

		clc				;Return with carry clear
		ret

NoASPIManager:	lea	dx,Str_NoASPI		;Display error message, no
		call	outtext			;  ASPI manager found
		stc				;Return with carry set
		ret
GetASPIEntry	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  FindDiskDrive
;
; Description:  This routine will scan all the ASPI host adapters for a SCSI
;		disk drive (Peripheral Device Type 0 or 7).  NOTE:  ASPI
;		"Get Device Type" is used rather than scanning the SCSI bus.
;
; Entry:  Nothing
;
; Exit:   CF set if no disk drive found, else reset
;****************************************************************************
CodeInit	segment
FindDiskDrive	proc	near

		mov	HANumber,0		;Start with Host Adapter #0

ScanNxtAdapter:	xor	cx,cx			;Start with target #0

ScanNxtTarget:	call	TargetPresent		;Is there a target here?
		jc	NextTarget		;Branch if there isn't
		cmp	al,0			;Is it a disk drive?
		je	ValidDevice		;Branch if it is
		cmp	al,7			;Is it an optical drive?
		jne	NextTarget		;Branch if it isn't

ValidDevice:	call	DeviceUnderBIOS		;Is device under the BIOS?
		jc	NextTarget		;Skip if under old ASPI mgr.
		cmp	al,0			;Under BIOS/DOS control?
		jne	NextTarget		;Branch if it is

		mov	TargetID,cl		;Save drive target ID
		jmp	SHORT FindDrvsPass

NextTarget:	inc	cx			;Move to next target
		cmp	cx,8			;End of target list?
		jne	ScanNxtTarget		;Branch if not

		inc	HANumber		;Move to next host adapter
		mov	al,HANumber
		cmp	al,NumberOfHA		;End of host adapter list?
		jb	ScanNxtAdapter		;Branch if not

		lea	dx,Str_NoDrives		;No disk drive found!!
		call	outtext
		jmp	SHORT FindDrvsFail

FindDrvsPass:	clc
		ret
FindDrvsFail:	stc
		ret
FindDiskDrive	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  TargetPresent
;
; Description:  This routine determines whether the given target is present
;		or not.  ASPI's "Get Device Type" routine is used.
;
; Entry:  CX - Target #
;	  HANumber - Host Adapter #
;
; Exit:   CF set if no device present
;	  CF clear if device present - AL = Peripheral device type
;	  All other registers preserved
;****************************************************************************
CodeInit	segment
TargetPresent	proc	near
		push	si			;Save registers

		lea	si,SRB
		call	ClearSRB		;Zero out our SRB
		mov	[si].SRB_Cmd,GET_DEV_TYPE ;"Get Device Type" command
		mov	al,HANumber
		mov	[si].SRB_HaId,al	;Set host adapter #
		mov	[si].SRB_Target,cl	;Set target #

		push	ds
		push	si
		call	[ASPI_Entry]		;Call ASPI
		add	sp,4

		cmp	[si].SRB_Status,SRB_COMP ;Is the target present?
		jne	NoTarget		;Branch if isn't
		mov	al,[si].TargDeviceType	;Store device type in AL
		clc				;Device is present

TargPresExit:	pop	si			;Restore stack and
		ret				;  return to caller

NoTarget:	stc				;Device is not present
		jmp	SHORT TargPresExit
TargetPresent	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  DeviceUnderBIOS
;
; Description:  This routine determines whether the given target is under
;		the BIOS' control or not.
;
; Entry:  CX - Target #
;	  HANumber - Host Adapter #
;
; Exit:   CF set if device under an "old" ASPI manager else reset
;	  AL = 0 if device not under BIOS control, else AL = 1
;	  All other registers preserved if CF clear.
;****************************************************************************
CodeInit	segment
DeviceUnderBIOS	proc	near
		push	si

		lea	si,SRB
		call	ClearSRB		;Zero out our SRB
		mov	[si].SRB_Cmd,GET_DRIVE_INFO
		mov	al,HANumber
		mov	[si].SRB_HaId,al	;Set host adapter #
		mov	[si].SRB_Target,cl	;Set target #

		push	ds
		push	si
		call	[ASPI_Entry]		;Call ASPI
		add	sp,4

		cmp	[si].SRB_Status,SRB_COMP ;Is the target present?
		jne	OldASPIMgr		;Branch if "old" ASPI mgr.
		mov	al,0			;Assume not under BIOS
		test	[si].DriveFlags,01h	;Drive under BIOS control?
		je	UnderBIOSPass		;Branch if it isn't
		mov	al,1			;  else AL=1
UnderBIOSPass:	clc
UnderBIOSExit:	pop	si
		ret

OldASPIMgr:	cmp	OldASPIGiven,0		;Already warned??
		jne	UserTold		;Branch if already warned
		mov	OldASPIGiven,1		;Notify user that an
		lea	dx,Str_OldASPIMgr	;  unsupported ASPI manager
		call	outtext			;  was found!
UserTold:	stc				;Return with carry set
		jmp	SHORT UnderBIOSExit
DeviceUnderBIOS	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  GetBPBInfo
;
; Description:  This is the heart of the initialization routine.  It goes
;		out and reads the master boot record of our disk drive.
;		If a primary DOS partition is found, ASPI1DSK will attach
;		it to DOS.  This routine leaves with the BPB structures
;		properly initialized.
;
; Entry:  Nothing
;
; Exit:   CF set if error occurred, else reset.
;****************************************************************************
CodeInit	segment
GetBPBInfo	proc	near
		lea	si,bpb_ptr		;SI = Array of BPB pointers
		lea	di,bpb_tbl		;DI = Base pointer to BPBs

		mov	dl,TargetID	  	;DL = target's SCSI ID
		call	DispTargAddress		;Display target location

		mov	al,NumberOfUnits	;Get target's starting unit #
		mov	OrigUnitNum,al		;Save it away for now

		call	ReadMBootRec		;Read the partitions
		jc	GetBPBInfoFail		;Branch if it failed
		call	DispTargInfo		;Display drive info

		lea	dx,Str_CRLF		;Add a <CR><LF>
		call	outtext

		cmp	bpb_ptr[0],0		;Did we find any partitions?
		jne	DevicesFound		;Branch if we did

		lea	dx,Str_NoDrives		;Otherwise, tell the user that
		call	outtext			;  there are no partitions
		jmp	SHORT GetBPBInfoFail	;  for ASPI1DSK to control!

DevicesFound:	clc				;Return without error
		ret

GetBPBInfoFail:	stc				;Return with fatal error
		ret
GetBPBInfo	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  DispTargAddress
;
; Description:  This routine takes the given target and displays its
;		location.  (ie. "    HA #0 - SCSI ID 2: "
;
; Entry:  DL    - Target SCSI ID
;	  HANumber - Host Adapter #
;
; Exit:   All registers preserved
;****************************************************************************
CodeInit	segment
DispTargAddress	proc	near
		pusha

		lea	bx,Str_TargetInfo1	;Get Target location string
		mov	al,HANumber
		add	al,'0'			;AL = ASCII Host Adapter #
		mov	BYTE PTR [bx+8],al	;Place HA # in string
		mov	al,dl
		add	al,'0'			;AL = ASCII Target #
		mov	BYTE PTR [bx+20],al	;Place target # in string
		mov	dx,bx
		call	outtext			;Display string

		popa				;Restore all registers
		ret				;  and return to caller
DispTargAddress	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  DispTargInfo
;
; Description:  This routine display's the given target's logical drive
;		info.  A sample display might look like this:
;
;		"    HA #0 - SCSI ID 2: 1 logical drive D: installed"
;
; Entry:  OrigUnitNum - Drive's starting unit #
;	  NumberOfUnits - Total # of units so far
;
; Exit:   All registers preserved
;****************************************************************************
CodeInit	segment
DispTargInfo	proc	near
		pusha

		mov	ah,0
		mov	al,NumberOfUnits	;AX = Total # of units
		sub	al,OrigUnitNum		;AX = # of units for target
		lea	dx,TempBuffer		;Use our temporary buffer
		mov	cx,10			;  to convert AX to ASCII
		mov	bp,1			;Don't add <CR><LF>
		call	itoa			;Convert to ASCII
		call	outtext			;Display # of target units
		lea	dx,Str_TargetInfo2
		call	outtext
		mov	al,NumberOfUnits
		sub	al,OrigUnitNum		;AX = # of units for target
		cmp	al,0			;No units?
		jne	Continue		;Branch if there are
		jmp	SHORT DispCRLF

Continue:	lea	dx,Str_TargetInfo3
		mov	bx,dx
		mov	al,OrigUnitNum		;AL = Targ's starting unit #
		add	al,'A'			;Convert to DOS Drive letter
		mov	[bx+0],al		;Place it in our string
		call	outtext			;  and display to user

DispCRLF:	lea	dx,Str_CRLF
		call	outtext			;Display <CR><LF>

DispTargExit:	popa				;Restore all registers
		ret				;  and return to caller
DispTargInfo	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  ReadMBootRec
;
; Description:  This routine reads the given target's partitions and fills
;		the given BPB entries with the values read from the
;		partitions.
;
; Entry:  SI - Array of BPB pointers - Next available pointer
;	  DI - Next available BPB
;	  DL - Target #
;
; Exit:	  CF set if fatal error occurred, else reset
;****************************************************************************
CodeInit	segment
ReadMBootRec	proc	near

RdNextMBoot:	call	RMBoot			;Read the master boot record
		jc	ReadMBootFail

ScanForParts:	lea	bx,mbrbuf[1BEh]		;Scan partition table
ScanNxtPart:	mov	al,BYTE PTR [bx+4]	;Get Partition System ID
		cmp	al,1			;12-bit FAT?
		je	ReadBoot		;Branch if it is
		cmp	al,4			;16-bit FAT?
		je	ReadBoot		;Branch if it is
		cmp	al,6			;DOS >4 Partition?
		je	ReadBoot		;Branch if it is
		jmp	SHORT SkipPartition	;Check the next partition
ReadBoot:	call	ReadBootRec		;Read in partition boot record
		jc	ReadMBootFail
		jmp	SHORT ReadMBootPass

SkipPartition:	add	bx,10h			   ;Move to next partition
		cmp	bx,DataOffset mbrbuf+1EEh  ;End of partition table?
		jbe	ScanNxtPart		   ;Loop until it is

ReadMBootPass:	clc
		ret				;Return without error

ReadMBootFail:	lea	dx,Str_BootFail		;Unable to read in a boot
		call	outtext			;  record, notify the user.
		jmp	SHORT ReadMBootPass
ReadMBootRec	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  ReadBootRec
;
; Description:  This routine will read in the given boot record.  If a valid
;		boot record is found, it will be attached to DOS.
;
; Entry:  SI - Array of BPB pointers - Next available pointer
;	  DI - Next available BPB
;	  BX - Partition table entry
;
; Exit:   SI,DI,BP,BX - preserved
;****************************************************************************
CodeInit	segment
ReadBootRec	proc	near

		cmp	NumberOfUnits,26	;Don't go beyond maximum
		jae	ReadBootExit		;  number of units
		mov	WORD PTR brdbuf[1FEh],0	;Zero out AA55 location
		push	bx
		call	RdBoot			;Read the boot record
		pop	bx

		cmp	WORD PTR brdbuf[1FEh],0AA55h ;Valid boot record?
		jne	ReadBootFail		     ;Skip if not
		cmp	WORD PTR brdbuf[26],40h	     ;64 head translation?
		jne	ReadBootFail		     ;Skip part. if not

		inc	NumberOfUnits		;Inc. total # of units

		push	si
		push	di			;Save SI,DI
		mov	ax,ds
		mov	es,ax			;ES=DS
		lea	si,brdbuf[11]
		mov	cx,25
		cld				;Copy BPB from boot record
		rep	movsb			;  to our array of BPBs
		pop	di
		pop	si			;Restore SI,DI

		mov	[di].tarlun_num,dl	;Save target #

		mov	WORD PTR [si],di	;Move to next ptr in array
		add	si,2			;  of BPBs
		add	di,SIZE DRV_BPB

ReadBootExit:	clc
		ret

ReadBootFail:	stc
		ret
ReadBootRec	endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  RMBoot
;
; Description:  Read Master Boot Record into 'mbrbuf' buffer.
;
; Entry:  DL       - Target number
;	  HANumber - Host Adapter #
;
; Exit:   CF set if unable to read sector, else reset
;****************************************************************************
CodeInit	segment
RMBoot		proc	near
		push	si
		push	dx
		push	es

		lea	si,SRB			;SI points to our SRB
		call	ClearSRB		;Zero out the SRB
		mov	[si].SRB_Cmd,EXEC_SCSI_CMD  ;Mark SRB as executable
		mov	al,HANumber
		mov	[si].SRB_HaId,al	    ;Set host adapter #
		mov	[si].SRB_Target,dl	    ;Set target ID
		mov	[si].SRB_Flags,SRB_DIR_IN   ;Inbound data transfer
		mov	[si].SRB_CDBLen,10	    ;10-byte CDB
		mov	[si].SRB_SenseLen,SENSE_LEN ;Sense length
		mov	[si].SRB_BufLenLo,200h	    ;200h byte transfer
		mov	[si].SRB_BufOffset,DataOffset mbrbuf  ;Buffer offset
		mov	[si].SRB_BufSegment,ds		      ;Buffer segment

		mov	[si].CDBByte[0],SCSI_READ10  ;10-byte SCSI READ
		mov	[si].CDBByte[8],01	;Single-sector read command
		call	ExeSCSICmd		;Execute the SCSI command
		call	ChkForError		;Check if error

		pop	es
		pop	dx
		pop	si
		ret
RMBoot		endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  RdBoot
;
; Description:  Read boot record into 'brdbuf' buffer.
;
;	 NOTE:  Currently, this routine uses the target ID left in the
;		SRB from the RMBoot routine.
;
; Entry:  BX - point to the partition table entry.
;	  DI - Next available BPB
;
; Exit:   CF set if unable to read sector, else reset
;****************************************************************************
CodeInit	segment
RdBoot		proc	near
		push	si
		push	cx
		push	dx
		push	es

		lea	si,SRB
		mov	[si].SRB_Cmd,EXEC_SCSI_CMD  ;Mark SRB as executable
		mov	al,HANumber
		mov	[si].SRB_HaId,al	    ;Set host adapter #
		mov	[si].SRB_Flags,SRB_DIR_IN   ;Inbound data transfer
		mov	[si].SRB_CDBLen,10	    ;10-byte CDB
		mov	[si].SRB_SenseLen,SENSE_LEN ;Sense length
		mov	[si].SRB_BufLenLo,200h	    ;200h byte transfer
		mov	[si].SRB_BufOffset,DataOffset brdbuf  ;Buffer offset
		mov	[si].SRB_BufSegment,ds		      ;Buffer segment
		mov	dx,WORD PTR [bx+08h]	;Get sector # of
		mov	cx,WORD PTR [bx+0Ah]	;  boot record

		mov	[di].start_secmsb,cl	;Store starting sector #
		mov	[di].start_secmid,dh	;  in our BPB
		mov	[di].start_seclsb,dl

		mov	[si].CDBByte[0],SCSI_READ10  ;10-byte SCSI READ
		mov	[si].CDBByte[3],cl
		mov	[si].CDBByte[4],dh
		mov	[si].CDBByte[5],dl	;Set sector #
		mov	[si].CDBByte[8],01	;Single-sector read command
		call	ExeSCSICmd		;Execute the SCSI command
		call	ChkForError		;Check if error

		pop	es
		pop	dx
		pop	cx
		pop	si
		ret
RdBoot		endp
CodeInit	ends

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		 %%% STRING MANIPULATION ROUTINES %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

;***************************************************************************
; Subroutine Name:  outtext
;
; Description:  Displays a message on the screen.
;
; Entry:  DS:DX - Pointer to '$' terminated character string
;
; Exit:   Nothing
;***************************************************************************
CodeInit	segment
outtext		proc	near
		push	ax
		mov	ah,09h
		int	21h
		pop	ax
		ret
outtext		endp
CodeInit	ends

;****************************************************************************
; Subroutine Name:  itoa
;
; Description:  Converts the digits of the given value to a '$'-terminated
;		character string.  Appends a carriage return and linefeed
;		to the end of the string as well if requested.
;
; Entry:  AX    - Number to be converted
;	  DS:DX - Pointer to string result
;	  CX    - Base of value (ie. 16 for hex, 10 for dec.)
;	  BP    - 0 if <CR><LF> should be added.
;
; Exit:   All registers preserved
;****************************************************************************
CodeInit	segment
itoa		proc	near
		pusha
		mov	bx,dx
		or	ax,ax			;Is input value zero?
		jne	NotZero			;Branch if it's not
		mov	BYTE PTR [bx],'0'	;  else fill string with
		inc	bx			;  a single '0' and exit
		jmp	SHORT itoa_exit

NotZero:	xor	di,di
NextDigit:	or	ax,ax			;Finished pushing remainders
		je	itoa_pop		;  onto the stack?
		xor	dx,dx
		div	cx			;Let's get the remainder
		push	dx			;Push the remainder
		inc	di			;Increment digit count
		jmp	NextDigit

itoa_pop:	or	di,di			;Finished popping digits?
		je	itoa_exit		;Branch and exit if we are
		pop	dx			;Pop a digit
		cmp	dl,10			;Is it a 0-9 digit?
		jb	DecDigit		;If it is convert to ASCII
		add	dl,'A'-10		;  else convert to HEX
		jmp	SHORT PlaceChar		;  alphabet
DecDigit:	add	dl,'0'
PlaceChar:	mov	[bx],dl			;Store character in string
		inc	bx			;Move to next place in string
		dec	di			;Decrement pop count
		jmp	itoa_pop		;Pop next value

itoa_exit:	or	bp,bp
		jne	NoCRLF
		mov	BYTE PTR [bx],CR	;Place Carriage Return &
		mov	BYTE PTR [bx+1],LF	;  and Line Feed and '$'
		mov	BYTE PTR [bx+2],'$'	;  char at end of string
		jmp	SHORT itoa_exit1

NoCRLF:		mov	BYTE PTR [bx],'$'
itoa_exit1:	popa				;Restore all registers
		ret
itoa		endp
CodeInit	ends

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		     %%% DISK DRIVER ROUTINES %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

;****************************************************************************
; Subroutine Name:  CmdNotSupported
;
; Description:  This device driver routine is called whenever an unsupported
;		command is issued.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
CmdNotSupported	proc	near
		mov	ax,(STAT_ERR SHL 8)+STAT_CMDERR	;Invalid command
		ret
CmdNotSupported	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  MediaCheck - Command Code 01h
;
; Description:  This device driver routine is called to determine whether the
;		disk medium on a block device has been changed.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
MediaCheck	proc	near
		xor	ax,ax			;No error
		mov	es:[bx].change,1	;Media has not changed
		ret
MediaCheck	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  BuildBPB - Command Code 02h
;
; Description:  This device driver routine builds a BIOS Parameter Block
;		(BPB) for the unit # embedded in the given request packet.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
BuildBPB	proc	near
		xor	dx,dx
		mov	dl,BYTE PTR es:[bx].unit  ;DX = Device unit #
		mov	si,dx			  ;SI = Device unit #
		shl	si,1			  ;SI = SI*2

		mov	bp,bpb_ptr[si]		;BP = Device BPB pointer
		mov	es:[bx].BPBptro,bp	;Store BPB pointer in
		mov	es:[bx].BPBptrs,ds	;  request packet
		ret
BuildBPB	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  DiskInput - Command Code 04h
;
; Description:  This device driver routine reads data from the disk to
;		the buffer specified in the given request packet.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
DiskInput	proc	near
		mov	req_cmd,SCSI_READ10	;Read - 10 byte CDB
		lea	si,SRB
		call	ClearSRB		;Zero out our SRB
		mov	[si].SRB_Flags,SRB_DIR_IN ;Inbound data transfer
		call	ReadWriteBlk		;Send ASPI command
		jnc	input_ok		;Branch if no failure
		ret

input_ok:	xor	ax,ax			;Command completed w/o error
		ret		
DiskInput	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  DiskOutput   - Command Code 08h
;		    OutputVerify - Command Code 09h
;
; Description:  This device driver routine writes data from the buffer to
;		the disk specified in the given request packet.  If the
;		OutputVerify command is issued, first a WRITE command is
;		sent followed by a VERIFY command.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
DiskOutput	proc	near
		mov	req_cmd,SCSI_WRITE10	;Write - 10 byte CDB
DiskOut:	lea	si,SRB
		call	ClearSRB		;Zero out our SRB
		mov	[si].SRB_Flags,SRB_DIR_OUT ;Outbound data transfer
		call	ReadWriteBlk		;Send ASPI command
		jnc	out_ok			;Branch if no failure
		ret

out_ok:		xor	ax,ax			;Command completed w/o error
		ret
DiskOutput	endp
ScsiCode	ends

ScsiCode	segment
OutputVerify	proc	near
		mov	req_cmd,SCSI_VERIFY10+80H  ;Mark as Write then Verify
		jmp	SHORT DiskOut		;Send the command.
OutputVerify	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  DeviceOpenClose - Command Code 0Dh
;				    - Command Code 0Eh
;
; Description:  This device driver routine handles the driver's device
;		open/close calls.  It simply returns without error.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
DeviceOpenClose	proc	near
		xor	ax,ax			;Return without error
		ret
DeviceOpenClose	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  RemovableMedia - Command Code 0Fh
;
; Description:  This device driver routine is used in DOS V3 and later
;		versions to determine whether the device has removable
;		media or not.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
RemovableMedia	proc	near
		mov	ax,STAT_BUSY		;Return BUSY bit of status
		ret				;  word = 1: Fixed Disk
RemovableMedia	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  GetSetDevice - Command Code 17h
;				   Command Code 18h
;
; Description:  This device driver routine will simply return zero in the
;		given request packet's unit # field.
;
; Entry:  ES:BX - Request Packet
;
; Exit:   AX - Status word
;****************************************************************************
ScsiCode	segment
GetSetDevice	proc	near
		mov	es:[bx].unit,0
		xor	ax,ax
		ret
GetSetDevice	endp
ScsiCode	ends

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		  %%% ASPI1DSK SUPPORT ROUTINES %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

;****************************************************************************
; Subroutine Name:  ClearSRB
;
; Description:  This routine zeros out the given ASPI SRB.
;
; Entry:  SI - ASPI SRB
;
; Exit:   All registers preserved
;****************************************************************************
ScsiCode	segment
ClearSRB	proc	near
		push	es			;Save registers
		push	ax
		push	cx
		push	di

		mov	cx,(SIZE SRB_with_CDB10)/2
		mov	ax,ds
		mov	es,ax			;ES=DS
		mov	di,si			;ES:DI points to SRB
		xor	ax,ax			;Store zeros
		cld
		rep	stosw			;Zero out the SRB

		pop	di
		pop	cx
		pop	ax
		pop	es			;Restore registers and
		ret				;  return to caller
ClearSRB	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  ReadWriteBlk
;
; Description:  This routine executes the driver Read/Write Block command
;		using the given parameters.
;
; Entry:  SI      - Points to ASPI SRB
;	  ES:BX   - Points to request header
;	  req_cmd - Type of command to execute
;
; Exit:   AX - status
;	  CF - set if error, else reset
;****************************************************************************
ScsiCode	segment
ReadWriteBlk	proc	near
		xor	dx,dx
		mov	dl,es:[bx].unit		;DX = Device unit #
		mov	di,dx			;DI = Device unit #
		shl	di,1			;DI = DI*2
		mov	bp,bpb_ptr[di]		;BP = Device BPB pointer

		mov	ah,req_cmd		;Get SCSI Command Code
		cmp	ah,SCSI_VERIFY10+80h	;Write then verify?
		jne	NotWrVerify		;Branch if not else
		mov	ah,SCSI_WRITE10		;  do write first

NotWrVerify:	mov	[si].SRB_Cmd,EXEC_SCSI_CMD  ;Mark SRB as executable
		mov	[si].CDBByte[0],ah	    ;Store SCSI Command Code
		mov	[si].SRB_CDBLen,10	    ;10-byte CDB
		mov	[si].SRB_SenseLen,SENSE_LEN ;Sense length
		push	es			;Save request block
		push	bx			;  pointer
		call	BuildRdWrSRB		;Finish building the SRB
		call	ExeSCSICmd		;Execute the SCSI command
		call	ChkForError		;Check for an error
		pop	bx			;Restore request block
		pop	es			;  pointer
		jc	RdWrExit		;Branch if command failed

		cmp	req_cmd,SCSI_VERIFY10+80h  ;Write then verify?
		jne	RdWrNoFail		   ;Branch if not

		mov	req_cmd,SCSI_VERIFY10	;Otherwise execute a verify
		mov	[si].SRB_Flags,0	;  command now since the
		jmp	SHORT ReadWriteBlk	;  write command finished

RdWrNoFail:	clc				;Return without error

RdWrExit:	ret
ReadWriteBlk	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  BuildRdWrSRB
;
; Description:  This routines takes a partially filled Read/Write SRB and
;		completes it.
;
; Entry:  BP    - Points to BPB table
;	  SI    - Points to ASPI SRB
;	  ES:BX - Points to request header
;
; Exit:   CF - set if timeout
;****************************************************************************
ScsiCode	segment
BuildRdWrSRB 	proc	near
		mov	al,HANumber
		mov	[si].SRB_HaId,al	;Set host adapter #
		mov	al,ds:[bp].tarlun_num
		mov 	[si].SRB_Target,al	;Set target #
		mov	ax,es:[bx].count	;AX = # sectors to transfer
		xor	ah,ah
		shl 	ax,1		  	
		mov	BYTE PTR [si].SRB_BufLenHi[0],ah ;Store buffer
		mov	BYTE PTR [si].SRB_BufLenLo[1],al ;  length

		mov	ax,es:[bx].xfer_off
		mov	[si].SRB_BufOffset,ax	;Set buffer offset
		mov	ax,es:[bx].xfer_seg
		mov	[si].SRB_BufSegment,ax	;Set buffer segment

		xor	ah,ah
		mov	al,ds:[bp].start_secmsb	;Assume DOS 4.0 and above
		mov	ch,ds:[bp].start_secmid	;  with 32-bit sectors
		mov	cl,ds:[bp].start_seclsb	;Get the starting sector #
		mov	dx,es:[bx].ss_num

		cmp	MajorDosVer,3		;Is it DOS 3.31???
		jne	NotDOS331
		cmp	MinorDosVer,31		;Branch if it isn't
		jne	NotDOS331

		mov	dx,es:[bx].ss_num[0]	;We're under DOS 3.31 so
		add	cx,dx			;  get 32-bit sector
		mov	dx,es:[bx].ss_num[2]	;  number from request
		adc	ax,dx			;  packet and process
		jmp	SHORT set_lbaddr

NotDOS331:	cmp	dx,-1			;32-bit sectors supported?
		jne	get_sctnum		;Branch if they are

		mov	dx,es:[bx].exsct_nlo	;32-bit sectors not allowed,
		add	cx,dx			;  get the 16-bit sector #
		mov	dx,es:[bx].exsct_nhi
		adc	ax,dx
		jmp	SHORT set_lbaddr

get_sctnum:	add	cx,dx
		adc	ax,0

set_lbaddr:	mov	[si].CDBByte[2],ah	;Store the starting sector #
		mov	[si].CDBByte[3],al	;  in the SRB
		mov	[si].CDBByte[4],ch
		mov	[si].CDBByte[5],cl
		mov	ax,es:[bx].count	;Store the number of sectors
		mov	[si].CDBByte[8],al	;  to transfer in the SRB

		ret				;Return to caller
BuildRdWrSRB	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  ExeSCSICmd
;
; Description:  Execute an ASPI command and poll for a returned status
;		after issuing the command.
;
; Entry:  SI - points to ASPI request block
;
; Exit:   CF - set if timeout
;	  All registers preserved except AX
;****************************************************************************
ScsiCode	segment
ExeSCSICmd	proc	near
		push	bp			;Save registers

		push	ds			;Pass SRB pointer on the
		push	si			;  stack
		call	DWORD PTR [ASPI_Entry]	;Call ASPI
		add	sp,4			;Restore stack
		mov	bp,TIME_OUT
		call	InitWatchdog		;Init timeout value

PollSRB:	sti
		mov	al,[si].SRB_Status	;Get SRB status
		cmp	al,SRB_PENDING		;SRB still pending?
		jne	NoTimeout		;Exit if not
		call	CheckWatchdog		;  else check for timeout
		jnc	PollSRB			;Loop if no timeout
		jmp	SHORT ExeDone		;Exit with carry set

NoTimeout:	clc
ExeDone:	pop	bp			;Restore registers and
		ret				;  return to caller
ExeSCSICmd	endp
ScsiCode	ends

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		       %%% TIMEOUT ROUTINES %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

ScsiData	segment
TimeoutTime	dd	?
ScsiData	ends

;****************************************************************************
; Subroutine Name:  InitWatchdog
;
; Description:  This routine initializes the watchdog timer to the given
;		timeout.  See the routine 'CheckWatchdog'.
;
; Entry:  BP - Timeout in 1/18ths of a second
;
; Exit:   All registers preserved
;****************************************************************************
ScsiCode	segment
InitWatchdog	proc	near
		push	es
		push	bx
		push	cx

		mov	bx,DOS_TIME_SEG
		mov	es,bx
		mov	cx,WORD PTR es:DOS_TIME_OFF
		mov	bx,WORD PTR es:DOS_TIME_OFF+2
		add	cx,bp
		adc	bx,0
		cmp	bx,18h
		jb	NotLate
		xor	bx,bx
		mov	cx,bp
		cmp	cx,DOS_TIME_ROLL
		ja	NotLate
		mov	cx,DOS_TIME_ROLL+1

NotLate:	mov	WORD PTR [TimeoutTime+0],cx
		mov	WORD PTR [TimeoutTime+2],bx

		pop	cx
		pop	bx
		pop	es
		ret
InitWatchdog	endp
ScsiCode	ends

;****************************************************************************
; Subroutine Name:  CheckWatchdog
;
; Description:  This routine checks if the watchdog timer has timed out.
;
; Entry:  Nothing
;
; Exit:   All registers preserved
;	  CF set if timer timed out, else reset
;****************************************************************************
ScsiCode	segment
CheckWatchdog	proc    near
		push	es
		push	ax
		push	bx
		push	cx

		mov	cx,WORD PTR [TimeoutTime+0]
		mov	bx,WORD PTR [TimeoutTime+2]
		mov	ax,DOS_TIME_SEG
		mov	es,ax
		cmp	bx,WORD PTR es:DOS_TIME_OFF+2
		ja	NoTmoFnd
		jb	PossTmoFnd

		cmp	cx,WORD PTR es:DOS_TIME_OFF
		jae	NoTmoFnd
		jmp	Short FoundTimeOut

PossTmoFnd:	or	bx,bx
		je	NoTmoFnd

FoundTimeOut:	stc
		jmp	SHORT ChkWDogExit
NoTmoFnd:	clc
ChkWDogExit:	pop	cx
		pop	bx
		pop	ax
		pop	es
		ret
CheckWatchdog	endp
ScsiCode	ends

page
;/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;
;		      %%% ERROR HANDLER CODE %%%
;
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

;****************************************************************************
; Subroutine Name:  ChkForError
;
; Description:  This routine translates the extended sense code to the disk
;		driver status.
;
; Entry:  CF - Flag of ASPI command execution (set if timeout occurred)
;	  SI - ASPI SRB pointer
;
; Exit:   CF - Set if error (AX contains error code), else reset
;	  AX - Error status if CF seg
;	  All other registers preserved
;****************************************************************************
ScsiCode	segment
ChkForError	proc    near
		jc	SetGenFailure		;Branch if SCSI timeout

TimeOk:		cmp	[si].SRB_Status,SRB_COMP ;SRB Completed without error?
		jne	ChkErr0			;Branch if not
		clc				;  otherwise return without
		ret				;  error

ChkErr0:	cmp	[si].SRB_Status,SRB_ERR	;SRB Completed with error?
		je	ChkHst0			;Branch if not
		jmp	SHORT SetGenFailure	;  otherwise general failure

ChkHst0:	cmp	[si].SRB_TargStat,0	;Non-zero target status?
		jne	ChkTst0			;Branch if it is
		jmp	SHORT SetGenFailure	;  otherwise general failure

ChkTst0:	mov	al,[si].SRB_TargStat	;AL = target status
		cmp	al,STATUS_CHKCOND	;Check condition?
		je	ChkSense		;Branch if it is
		cmp	al,STATUS_BUSY		;Target busy?
		jne	ChkTst1			;Branch if it isn't
		mov	al,STAT_DNRDY		;  else set not ready error
		jmp	SHORT CstDone

ChkTst1:	cmp	al,STATUS_RESCONF	;Reservation conflict?
		jne	SetGenFailure		;Branch if it isn't
		mov	al,STAT_DNRDY		;  else set not ready error
		jmp	SHORT CstDone

ChkSense:	mov	al,[si].SenseArea10.AddSenseCode  ;Get sense code

ChkSns_cont:	cmp	al,CSNMAX		;Sense code in range?
		jb	GetSnsCont		;Branch if is
		jmp	SHORT SetGenFailure	;  otherwise general failure

GetSnsCont:	push	bx
		lea	bx,ECDTBL
		xlat	[bx]			;Translate extended sense
		pop	bx			;  code into AL
		jmp	SHORT CstDone

SetGenFailure:	mov	al,STAT_GENF		;Set general failure error

CstDone:	mov	ah,STAT_ERR
		stc
		ret
ChkForError	endp
ScsiCode	ends

;****************************************************************************
;			 %%% ERROR CODES %%%
;****************************************************************************
ScsiData	segment
ECDTBL		LABEL	BYTE
		db	STAT_GENF	;00H - No additional sense information
		db	STAT_GENF	;01H - No index/sector signal
		db	STAT_SEEK	;02H - No seek complete
		db	STAT_GENF	;03H - Write fault
		db	STAT_DNRDY	;04H - Drive not ready
		db	STAT_GENF	;05H - Drive not selected
		db	STAT_GENF	;06H - No track zero found
		db	STAT_GENF	;07H - Multiple drives selected
		db	STAT_GENF	;08H - Logical unit communication failure
		db	STAT_GENF	;09H - Track following error
		db	STAT_GENF	;0AH - Reserved
		db	STAT_GENF	;0BH - Reserved
		db	STAT_GENF	;0CH - Reserved
		db	STAT_GENF	;0DH - Reserved
		db	STAT_GENF	;0EH - Reserved
		db	STAT_GENF	;0FH - Reserved
		db	STAT_CRC	;10H - ID CRC or ECC error
		db	STAT_CRC	;11H - Unrecovered Read error of data blocks
		db	STAT_GENF	;12H - No address mark found in ID field
		db	STAT_GENF	;13H - No address mark found in data field
		db	STAT_SNF	;14H - No record found
		db	STAT_SEEK	;15H - Seek positioning error
		db	STAT_SNF	;16H - Data synchroniztion mark error
		db	STAT_GENF	;17H - Recovered read data with retries
		db	STAT_GENF	;18H - Recovered read data with correction
		db	STAT_CMDERR	;19H - Defect list error
		db	STAT_CMDERR	;1AH - Parameter overrun
		db	STAT_GENF	;1BH - Synchronous transfer error
		db	STAT_GENF	;1CH - Primary defect list not found
		db	STAT_GENF	;1DH - Compare error
		db	STAT_GENF	;1EH - Recovered ID with ECC correction
		db	STAT_GENF	;1FH - Reserved
		db	STAT_CMDERR	;20H - Invalid command operation code
		db	STAT_GENF	;21H - Illegal logical block address
		db	STAT_CMDERR	;22H - Illegal function for device type
		db	STAT_GENF	;23H - Reserved
		db	STAT_CMDERR	;24H - Illegal field in Cdb
		db	STAT_CMDERR	;25H - Invalid LUN
		db	STAT_CMDERR	;26H - Invalid field in parameter list
		db	STAT_WTPRT	;27H - Write protected
		db	STAT_DNRDY	;28H - Medium changed
		db	STAT_DNRDY	;29H - Power on reset or bus device reset
		db	STAT_DNRDY	;2AH - Mode select parameters changed
		db	STAT_GENF	;2BH - Reserved
		db	STAT_GENF	;2CH - Reserved
		db	STAT_GENF	;2DH - Reserved
		db	STAT_GENF	;2EH - Reserved
		db	STAT_GENF	;2FH - Reserved
		db	STAT_CMDERR	;30H - Incompatible cartridge
		db	STAT_CMDERR	;31H - Medium format corrupted
		db	STAT_CMDERR	;32H - No defect spare location available
		db	STAT_CMDERR	;33H - Reserved
		db	STAT_GENF	;34H - Reserved
		db	STAT_GENF	;35H - Reserved
		db	STAT_GENF	;36H - Reserved
		db	STAT_GENF	;37H - Reserved
		db	STAT_GENF	;38H - Reserved
		db	STAT_GENF	;39H - Reserved
		db	STAT_GENF	;3AH - Reserved
		db	STAT_GENF	;3BH - Reserved
		db	STAT_GENF	;3CH - Reserved
		db	STAT_GENF	;3DH - Reserved
		db	STAT_GENF	;3EH - Reserved
		db	STAT_GENF	;3FH - Reserved
		db	STAT_GENF	;40H - RAM failure
		db	STAT_GENF	;41H - Data path diagnostic failure
		db	STAT_GENF	;42H - Power on diagnostic failure
		db	STAT_GENF	;43H - Message reject error
		db	STAT_GENF	;44H - Internal controller error
		db	STAT_DNRDY	;45H - Select/reselect failed
		db	STAT_DNRDY	;46H - Unsuccessful soft reset
		db	STAT_GENF	;47H - SCSI interface parity error
		db	STAT_GENF	;48H - Initiator detected error
		db	STAT_GENF	;49H - Inappropriate/illegal message
ECDTBL_END	LABEL	byte

CSNMAX		equ	(ECDTBL_END-ECDTBL)

ScsiData	ends

		END START

