/******************************************************************************
**
**  Module Name:    seqtest.h
**
**  Description:    Header file for the SeqTest sample application.
**
**  History:        11/30/96 (dap)  Initial creation.
**
**  Notes:          This file created using 4 spaces per tab.
**
******************************************************************************/

#ifndef __SEQTEST_H__
#define __SEQTEST_H__

//*****************************************************************************
//*****************************************************************************

#define SAMPLES         8               // Number of ^2 samples from 4KB
#define SIZE_INQUIRYBUF 36              // SCSI Inquiry buffer size
#define SIZE_READCAPBUF 8               // Size of READ CAPACITY buffer

//*****************************************************************************
//*****************************************************************************

typedef struct tag_BENCHTARGET
{
    BYTE                    byHaId;
    BYTE                    byTarget;
    DWORD                   dwMaxTransferBytes;
    DWORD                   dwThroughput[SAMPLES];
    struct tag_BENCHTARGET  *pbtNext;
}
BENCHTARGET, *PBENCHTARGET;

//*****************************************************************************
//*****************************************************************************

typedef struct
{
    BYTE        byError;                    // Error code
    UINT        uID;                        // String table index
}
ERRORCODES, *PERRORCODES;

//*****************************************************************************
//*****************************************************************************

#define MOVESCSIDWORD(pdwSrc,pdwDst) \
{\
    ((PBYTE)(pdwDst))[0] = ((PBYTE)(pdwSrc))[3];\
    ((PBYTE)(pdwDst))[1] = ((PBYTE)(pdwSrc))[2];\
    ((PBYTE)(pdwDst))[2] = ((PBYTE)(pdwSrc))[1];\
    ((PBYTE)(pdwDst))[3] = ((PBYTE)(pdwSrc))[0];\
}

#define MOVESCSIWORD(pwSrc,pwDst) \
{\
    ((PBYTE)(pwDst))[0] = ((PBYTE)(pwSrc))[1];\
    ((PBYTE)(pwDst))[1] = ((PBYTE)(pwSrc))[0];\
}

//*****************************************************************************
//*****************************************************************************

#endif __SEQTEST_H__
